LibreOffice LibreOffice 4.3 SDK C/C++ API Reference

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Classes | Public Member Functions | Protected Member Functions | List of all members
cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 > Class Template Reference

Implementation helper implementing interfaces com::sun::star::lang::XTypeProvider and com::sun::star::uno::XInterface inherting from a BaseClass. More...

`#include <implbase4.hxx>`

Inheritance diagram for cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >:

## Public Member Functions
| ImplInheritanceHelper4 ()
virtual com::sun::star::uno::Any | queryInterface (com::sun::star::uno::Type const &rType) SAL_OVERRIDE throw (com::sun::star::uno::RuntimeException)
virtual void | acquire () SAL_OVERRIDE throw ()
virtual void | release () SAL_OVERRIDE throw ()
virtual com::sun::star::uno::Sequence < com::sun::star::uno::Type > | getTypes () SAL_OVERRIDE throw (com::sun::star::uno::RuntimeException)
virtual com::sun::star::uno::Sequence < sal_Int8 > | getImplementationId () SAL_OVERRIDE throw (com::sun::star::uno::RuntimeException)

## Protected Member Functions
template<typename T1 >
| ImplInheritanceHelper4 (T1 const &arg1)
template<typename T1 , typename T2 >
| ImplInheritanceHelper4 (T1 const &arg1, T2 const &arg2)
template<typename T1 , typename T2 , typename T3 >
| ImplInheritanceHelper4 (T1 const &arg1, T2 const &arg2, T3 const &arg3)
template<typename T1 , typename T2 , typename T3 , typename T4 >
| ImplInheritanceHelper4 (T1 const &arg1, T2 const &arg2, T3 const &arg3, T4 const &arg4)
template<typename T1 , typename T2 , typename T3 , typename T4 , typename T5 >
| ImplInheritanceHelper4 (T1 const &arg1, T2 const &arg2, T3 const &arg3, T4 const &arg4, T5 const &arg5)
template<typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 >
| ImplInheritanceHelper4 (T1 const &arg1, T2 const &arg2, T3 const &arg3, T4 const &arg4, T5 const &arg5, T6 const &arg6)

## Detailed Description

### template<class BaseClass, class Ifc1, class Ifc2, class Ifc3, class Ifc4>
class cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >

Implementation helper implementing interfaces com::sun::star::lang::XTypeProvider and com::sun::star::uno::XInterface inherting from a BaseClass.

All acquire() and release() calls are delegated to the BaseClass. Upon queryInterface(), if a demanded interface is not supported by this class directly, the request is delegated to the BaseClass.

Attention
  The BaseClass has to be complete in a sense, that com::sun::star::uno::XInterface and com::sun::star::lang::XTypeProvider are implemented properly. The BaseClass must have at least one ctor that can be called with six or fewer arguments, of which none is of non-const reference type.

Derive:

Inherit from this class giving your additional interface(s) to be implemented as template argument(s). Your sub class defines method implementations for these interface(s).

## Constructor & Destructor Documentation

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >
template<typename T1 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( | T1 const & | arg1 | ) |
| inline explicit protected

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >
template<typename T1 , typename T2 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( | T1 const & | arg1,
|  | T2 const & | arg2
| ) |  |
| inline protected

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >
template<typename T1 , typename T2 , typename T3 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( | T1 const & | arg1,
|  | T2 const & | arg2,
|  | T3 const & | arg3
| ) |  |
| inline protected

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >
template<typename T1 , typename T2 , typename T3 , typename T4 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( | T1 const & | arg1,
|  | T2 const & | arg2,
|  | T3 const & | arg3,
|  | T4 const & | arg4
| ) |  |
| inline protected

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >
template<typename T1 , typename T2 , typename T3 , typename T4 , typename T5 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( | T1 const & | arg1,
|  | T2 const & | arg2,
|  | T3 const & | arg3,
|  | T4 const & | arg4,
|  | T5 const & | arg5
| ) |  |
| inline protected

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >
template<typename T1 , typename T2 , typename T3 , typename T4 , typename T5 , typename T6 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( | T1 const & | arg1,
|  | T2 const & | arg2,
|  | T3 const & | arg3,
|  | T4 const & | arg4,
|  | T5 const & | arg5,
|  | T6 const & | arg6
| ) |  |
| inline protected

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >

cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::ImplInheritanceHelper4 | ( |  | ) |
| inline

## Member Function Documentation

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >

virtual void cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::acquire | ( |  | ) |
throw | ( |
| ) |  |
| inline virtual

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >

virtual com::sun::star::uno::Sequence< sal_Int8 > cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::getImplementationId | ( |  | ) |
throw | ( | com::sun::star::uno::RuntimeException
| ) |  |
| inline virtual

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >

virtual com::sun::star::uno::Sequence< com::sun::star::uno::Type > cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::getTypes | ( |  | ) |
throw | ( | com::sun::star::uno::RuntimeException
| ) |  |
| inline virtual

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >

virtual com::sun::star::uno::Any cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::queryInterface | ( | com::sun::star::uno::Type const & | rType | ) |
throw | ( | com::sun::star::uno::RuntimeException
| ) |  |
| inline virtual

template<class BaseClass , class Ifc1 , class Ifc2 , class Ifc3 , class Ifc4 >

virtual void cppu::ImplInheritanceHelper4< BaseClass, Ifc1, Ifc2, Ifc3, Ifc4 >::release | ( |  | ) |
throw | ( |
| ) |  |
| inline virtual

The documentation for this class was generated from the following file:

- cppuhelper/implbase4.hxx